---
- name: Common functionality for all Arvados hosts
  hosts: localhost
  gather_facts: true
  become: true

  tasks:
    - name: Assert Ubuntu
      when: ansible_os_family != 'Debian'
      fail:
        msg: | 
          This plugin-suite is written for Ubuntu workspaces.
          Feel free to extend it for others.
          (e.g. conditionally use 'yum' instead of 'apt'.)

    - name: Signal that Samba-plugins have run successfully (apparently)
      # Wait for this message in the creation-log of the core server. 
      # Helps you not to start the keep/workbench/... servers too early.
      debug:
        msg: "SAMBA PLUGIN HAS FINISHED"

    - name: Install Arvados repo key
      args:
        warn: false
      shell: >
        curl https://apt.arvados.org/pubkey.gpg
        -o /etc/apt/trusted.gpg.d/arvados.asc

    - name: Add Arvados repo
    # sudo does not apply to "tee", here so write to a tmp-file   
      shell: >
        echo "deb http://apt.arvados.org/focal focal main"
        | tee /tmp/arvados.list


    - name: Copy intermediate file to /etc/apt/...
      copy:
        src: /tmp/arvados.list
        dest: /etc/apt/sources.list.d/arvados.list

    - name: Update
    # Ansible apt-module causes error. Have to use bare shell and suppress warning.
      args:
        warn: false
      shell: "apt-get update"

    # `wsp_fqdn` is in the form <hostname>.<cluster_id/co_name>.src.surf-hosted.nl
    # `src_domain` is in the form <cluster_id/co_name>.src.surf-hosted.nl
    - name: Extract SRC domain
      set_fact:
        src_domain: "{{ wsp_fqdn.split('.', 1)[1] }}"
        host_role: "{{ wsp_fqdn.split('.', 1)[0] }}"

    - name: Get cluster_id and SRC domain
      set_fact:
        # cluster ID is first 5 characters of subdomain: <service>.<cluster_id>.src.surf-hosted.nl
        cluster_id: "{{ src_domain[:5] }}"

    - name: Get fqdn-tail
      set_fact:
        fqdn_tail: "{{ (wsp_fqdn.split('.'))[1:]|join('.') }}"

    - name: Create api-token
      set_fact:
        api_token: "{{ api_token_secret }}"

    - name: Set env variables
      lineinfile:
        path: /etc/environment
        line: |
          ARVADOS_API_TOKEN={{api_token}}
          ARVADOS_API_HOST={{ 'core.' + src_domain }}

    - name: Get private ip address
      shell: hostname -I
      register: hostname_command

    - name: 
      set_fact:
        private_ip_address: "{{ hostname_command.stdout }}"




